      subroutine direct(inod,jnod,node,x,y,ni,nj,dnorm,ax,u,icell,jcell,
     &                  amat,isw,bc)

      implicit real*8(a-h,o-z)

      dimension inod(*),jnod(*),node(2,*),x(2,*),y(2,*),
     &          dnorm(2,*),ax(*),u(*),amat(ni,*), bc(2,*)

      data      pi/3.141592653589793D0/

	pi2 = pi*2.d0

      do j = 1, nj

        jind = jnod(j)

        al = sqrt((y(1,node(1,jind))-y(1,node(2,jind)))**2 +
     &            (y(2,node(1,jind))-y(2,node(2,jind)))**2)     ! Element length

        do i = 1, ni

          iind = inod(i)

          x11 = y(1,node(1,jind)) - x(1,iind)
          x21 = y(2,node(1,jind)) - x(2,iind)
          x12 = y(1,node(2,jind)) - x(1,iind)
          x22 = y(2,node(2,jind)) - x(2,iind)

          r1 =  sqrt(x11**2 + x21**2)
          r2 =  sqrt(x12**2 + x22**2)
          d  =  x11*dnorm(1,jind) + x21*dnorm(2,jind)
          t1 = -x11*dnorm(2,jind) + x21*dnorm(1,jind)
          t2 = -x12*dnorm(2,jind) + x22*dnorm(1,jind)

	    ds = abs(d)
            dtheta = datan2(ds*al,ds**2+t1*t2)

          aa = (-dtheta*ds + al + t1*log(r1)-t2*log(r2))/pi2
	    if(d .lt. 0.d0) dtheta = -dtheta
	    bb = -dtheta/pi2
	    if(iind .eq. jind) bb = 0.5d0

	  if(bc(1,jind) .eq. 1.) then
          ax(i) = ax(i) - aa*u(j)
          if(icell.eq.jcell .and. isw.eq.1) then    ! Store coefficients in 1st iteration
            amat(i,j) = - aa
          endif
	  else if(bc(1,jind) .eq. 2.) then
          ax(i) = ax(i) + bb*u(j)
          if(icell.eq.jcell .and. isw.eq.1) then    ! Store coefficients in 1st iteration
            amat(i,j) =   bb
          endif
	  endif

	  enddo

	enddo

      return
      end