      subroutine dwnwrd(u,ax,n,x,y,node,dnorm,bc,a,b,xmax,xmin,
     &                  ymax,ymin,ielem,itree,level,loct,numt,ifath,
     &                  nexp,ntylr,ncellmx,lowlev,maxl,rwork,iwork)

      implicit real*8(a-h,o-z)
      complex*16 a,b, z0,zi,zo,zp

      dimension a(0:nexp,ncellmx),b(0:ntylr,ncellmx),x(2,*),y(2,*), 
     &          node(2,*),dnorm(2,*),bc(2,*),u(*),ax(*),ielem(*),
     &          itree(*),level(0:*),loct(*),numt(*),ifath(*),
     &          rwork(*),iwork(*)

      data pi/3.141592653589793D0/

	pi2 = pi*2.d0

      do i=1,level(lowlev+1)-1
      do k=0,ntylr
         b(k,i) = (0.d0,0.d0)
	enddo
	enddo
      do i=1,n
         ax(i) = 0.d0
	enddo

      leaf = 0
      indr = 1
      indi = 1
      do 110 lev=2,lowlev       ! Downward from level 2 cells to leaf cells
         ndivx = 2**lev
         dx    = (xmax-xmin)/ndivx
         dy    = (ymax-ymin)/ndivx
         do 120 icell=level(lev),level(lev+1)-1 ! Loop for level l cells
            itr   = itree(icell)
            itrx  = mod(itr,ndivx)
            itry  = itr/ndivx                   ! Position of the cell
            cx    = xmin+(itrx + 0.5d0)*dx
            cy    = ymin+(itry + 0.5d0)*dy      ! Center of the cell
            itrxp = itrx/2
            itryp = itry/2

c From the parent cell (use L2L)

            if(lev.ne.2) then
               cxp = xmin+(itrxp*2+1)*dx
               cyp = ymin+(itryp*2+1)*dy        ! Center of the parent cell
               z0  = cmplx(cx-cxp, cy-cyp)
               io  = ifath(icell)               ! Cell number of the parent cell
               zi  = (1.d0,0.d0)
               do k=0,ntylr
                  do m=0,ntylr-k
                     b(m,icell) = b(m,icell) + zi*b(k+m,io) ! L2L translation
                  enddo
                  zi = zi*z0/(k+1)
               enddo
            endif

         do 130 jcell=level(lev),level(lev+1)-1
            jtr   = itree(jcell)
            jtrx  = mod(jtr,ndivx)
            jtry  = jtr/ndivx
            jtrxp = jtrx/2
            jtryp = jtry/2

c The parents must be neighbours

            if(iabs(itrxp-jtrxp).gt.1 .or. iabs(itryp-jtryp).gt.1)
     &         goto 130

c For non-neighbours (cells in interaction list) (use M2L)

            if(iabs(itrx-jtrx).gt.1 .or. iabs(itry-jtry).gt.1) then
               ccx = xmin + (jtrx + 0.5d0)*dx
               ccy = ymin + (jtry + 0.5d0)*dy   ! Center of the j cell (with moments)
               z0  = cmplx(cx-ccx, cy-ccy)

               b(0,icell) = b(0,icell) - log(z0)*a(0,jcell)
	         zo = 1.
	         do m=1,nexp+ntylr
                   zo   = zo/z0
                   kmin = max(0,m-nexp)
                   kmax = min(m,ntylr)
                   sgn  = (-1.0)**kmin
                   do k=kmin,kmax
                      b(k,icell) = b(k,icell) + sgn*zo*a(m-k,jcell) ! M2L translation
                      sgn = -sgn
                   enddo
                   zo = zo*m
                enddo

c Contribution from neighbouring leaves (use direct)

            elseif(numt(jcell).le.maxl .or.
     &             numt(icell).le.maxl .or. lev.eq.lowlev) then
               if(icell.eq.jcell) then
                  leaf  = leaf+1
                  leaf3 = leaf*3-1
                  if(iwork(leaf3).ne.icell) then
                     write(3,*) leaf,iwork(1),iwork(leaf3),icell,'check'
                     write(*,*) " icell error"
	               stop
                  endif
                  indr = iwork(leaf3+1)
                  indi = iwork(leaf3+2)
               endif

                  call direct(ielem(loct(icell)),ielem(loct(jcell)),
     &                       node,x,y,numt(icell),numt(jcell),dnorm,
     &                       ax(loct(icell)),u(loct(jcell)),icell,jcell,
     &                       rwork(indr),indi,bc)       ! Direct integration
            endif
 130     continue

c Compute Ax if reach a leaf (Evaluate local expansion at each collocation point)

      if(numt(icell).le.maxl .or. lev.eq.lowlev) then
         fact = 1.d0
            do itylr=1,ntylr
              fact = fact/itylr
              b(itylr,icell) = b(itylr,icell)*fact
            enddo
         do in=1,numt(icell)
            inax = loct(icell) + in-1       ! Element number in the tree structure
            indx = ielem(inax)              ! Original element number
            zp   = b(ntylr,icell)
            z0   = cmplx(x(1,indx)-cx, x(2,indx)-cy)
            do itylr=ntylr-1,0,-1
              zp = zp*z0 + b(itylr,icell)   ! Local expansion
		    enddo
            zp = zp/pi2
            ax(inax) = ax(inax) + dreal(zp) ! Array Ax
	   enddo
      endif

 120  continue
 110  continue

      return
      end