	subroutine fmmmain(maxa, maxia, am, ia, n,x,y,node,dnorm,bc, 
     &            a,b, xmax,xmin,ymax,ymin,ielem,itree,level,loct,numt,
     &            ifath,lowlev,maxl,levmx,nexp,ntylr,tolerance,ncellmx,
     &            nleafmx,mxl,u,ax,nfield,xfield,f,sb,sx,igwk,rgwk,
     &            ligw,lrgw,nwksz,iwksz,rwork,iwork)

      implicit real*8(a-h,o-z)
      complex*16 am(maxa), a,b
      dimension  ia(maxia),ja(1),a(0:nexp,ncellmx),b(0:ntylr,ncellmx),
     &           x(2,n),y(2,n),node(2,n),dnorm(2,n),bc(2,n),
     &           ielem(n),itree(ncellmx),level(0:levmx),loct(ncellmx),
     &           numt(ncellmx),ifath(ncellmx), u(n),ax(n),sb(n),sx(n),
     &           igwk(ligw),rgwk(lrgw),rwork(nwksz),iwork(iwksz),
     &           xfield(2,nfield),f(nfield)

      external  matvec, msolve

c Input parameters and prepare the BEM model

      call prep_model(n,x,y,node,bc,dnorm,xfield,nfield,maxl,levmx,
     &                nexp,ntylr,tolerance,xmin,xmax,ymin,ymax)

c Generate the quad-tree structure for the elements

      call tree(n,x,xmax,xmin,ymax,ymin,ielem,itree,level,loct,numt,
     &          ifath,lowlev,maxl,levmx,ncellmx,nleafmx,nwksz,iwork)

c Compute the right-hand-side vector b with the FMM

	call fmmbvector(n,x,y,node,dnorm,bc,u,ax,a,b,xmax,xmin,ymax,ymin,
     &                ielem,itree,level,loct,numt,ifath,
     &                nexp,ntylr,ncellmx,lowlev,maxl,rwork,iwork)

c Solve the BEM system of equations Ax=b with the FMM BEM

c Prepare parameters for calling the iterative solver GMRES 
c (SLATEC GMRES solver is used, which is available at www.netlib.org. 
c See the documentation for the SLATEC GMRES solver for more information  
c about the following related parameters)

      nelt    = 1
      isym    = 0
      itol    = 0
      tol     = tolerance
      iunit   = 3
      igwk(1) = mxl
      igwk(2) = mxl
      igwk(3) = 0
      igwk(4) = 1
      igwk(5) = 10
      do i=1,n
        ax(i) = 0.d0
      enddo

	write(*,*) 'Call Equation Solver GMRES ...'
      call dgmres(n,u,ax, nelt,ia,ja,am,isym, matvec,msolve,itol,tol,
     &            itmax,iter,er,ierr,iunit,sb,sx,rgwk,lrgw,igwk,ligw,
     &            rwork,iwork)
      write(3,*) ' Error indicator from GMRES:', ierr
      write(*,*) ' Error indicator from GMRES:', ierr

c Output the boundary solution

      do i=1,n
        u(ielem(i)) = ax(i)
      enddo

      write(3,*) ' FMM BEM Solution:'
      do i=1,n
        write(3,*) i, u(i)
        write(7,*) i, u(i)
	enddo

c Evaluate the field inside the domain and output the results

	call domain_field(nfield,xfield,f,n,x,y,bc,node,dnorm,u)

	return
      end