      subroutine matvec(n,u,ax,nelt,ia,ja,am,isym)

      implicit real*8(a-h,o-z)
      complex*16 am, a, b

      dimension u(*),ax(*),ia(*),ja(*),am(*)

c Retrieve the pointers

	l_n         = ia(1)
	l_x         = ia(2)
	l_y         = ia(3)
	l_node      = ia(4)
	l_dnorm     = ia(5)
	l_bc        = ia(6)
	l_a         = ia(7)
	l_b         = ia(8)
	l_xmax      = ia(9)
	l_xmin      = ia(10)
	l_ymax      = ia(11)
	l_ymin      = ia(12)
	l_ielem     = ia(13)
	l_itree     = ia(14)
	l_level     = ia(15)
	l_loct      = ia(16)
	l_numt      = ia(17)
	l_ifath     = ia(18)
	l_lowlev    = ia(19)
	l_maxl      = ia(20)
	l_levmx     = ia(21)
	l_nexp      = ia(22)
	l_ntylr     = ia(23)
	l_tolerance = ia(24)
	l_ncellmx   = ia(25)
	l_nleafmx   = ia(26)
	l_mxl       = ia(27)
	l_u         = ia(28)
	l_ax        = ia(29)
	l_sb        = ia(30)
	l_sx        = ia(31)
	l_ligw      = ia(32)
	l_lrgw      = ia(33)
	l_igwk      = ia(34)
	l_rgwk      = ia(35)
	l_nwksz     = ia(36)
	l_iwksz     = ia(37)
	l_rwork     = ia(38)
	l_iwork     = ia(39)

c Evaluate matrix-vector multiplication Ax using the FMM BEM

      call upward(u,       am(l_n),     am(l_y),       am(l_node), 
     &        am(l_dnorm), am(l_bc),    am(l_a),       am(l_xmax), 
     &        am(l_xmin),  am(l_ymax),  am(l_ymin),    am(l_ielem), 
     &        am(l_itree), am(l_level), am(l_loct),    am(l_numt),  
     &        am(l_ifath), am(l_nexp),  am(l_ncellmx), am(l_lowlev), 
     &        am(l_maxl))

      call dwnwrd(u,ax,    am(l_n),       am(l_x),      am(l_y),     
     &        am(l_node),  am(l_dnorm),   am(l_bc),     am(l_a),     
     &        am(l_b),     am(l_xmax),    am(l_xmin),   am(l_ymax),  
     &        am(l_ymin),  am(l_ielem),   am(l_itree),  am(l_level),
     &        am(l_loct),  am(l_numt),    am(l_ifath),  am(l_nexp),  
     &        am(l_ntylr), am(l_ncellmx), am(l_lowlev), am(l_maxl),  
     &        am(l_rwork), am(l_iwork))

      return
      end