      subroutine moment(a,y,node,ielem,num,nexp,cx,cy,u,bc,dnorm)

      implicit real*8(a-h,o-y)
      implicit complex*16(z)

      complex*16 a(0:*)
      dimension  y(2,*),node(2,*),ielem(*),u(*), bc(2,*),dnorm(2,*)

      do i=1,num    ! Over elements in the leaf

         nelm = ielem(i)                    ! Element number
         n1 = node(1,nelm)                  ! Two ends of the element
         n2 = node(2,nelm)                  
         z1 = cmplx(y(1,n1)-cx, y(2,n1)-cy) 
         z2 = cmplx(y(1,n2)-cx, y(2,n2)-cy) 
         zwbar = conjg(z2 - z1)             
         zwbar = zwbar/abs(zwbar)           ! omega bar
         zp1   = z1*zwbar                   
         zp2   = z2*zwbar                   
         znorm = cmplx(dnorm(1,nelm),dnorm(2,nelm)) ! complex normal n
         if(bc(1,nelm) .eq. 1.d0) then      ! Assign values to phi and q
           phi = 0.D0
           q   = u(i)
         else if(bc(1,nelm) .eq. 2.d0) then
           phi = u(i)
           q   = 0.D0
         endif
         
c Compute moments:
 
         a(0) = a(0) - (zp2-zp1)*q              ! G kernel
         do k=1,nexp
           a(k) = a(k) + (zp2-zp1)*znorm*phi    ! F kernel
           zp1  = zp1*z1/(k+1)
           zp2  = zp2*z2/(k+1)
           a(k) = a(k) - (zp2-zp1)*q            ! G kernel
         enddo

      enddo

      return
      end