c-------------------------------------------------------------------------------

      subroutine msolve(n,r,z,nelt,ia,ja,am,isym,rwork,iwork)

      implicit real*8(a-h,o-z)
      complex*16 am(*)

      dimension  r(*),z(*),ia(*),ja(1),rwork(*),iwork(*)

c Load the pointers

	l_loct = ia(16)
	l_numt = ia(17)

c Compute the pre-conditioning matrix

      call msolveinv(r,z,rwork,iwork, am(l_loct), am(l_numt))

      return
      end

c-------------------------------------------------------------------------------

      subroutine msolveinv(r,z,rwork,iwork,loct,numt)

      implicit real*8(a-h,o-z)

      dimension  r(*),z(*),iwork(*),rwork(*),loct(*),numt(*)

      nleaf = iwork(1)
      do l = 1,nleaf
         l3   = l*3-1
         inod = iwork(l3)
         indr = iwork(l3+1)
         indx = loct(inod)
         indi = indx+3*nleaf+1
         nr   = numt(inod)

         call dcopy(nr,r(indx),1,z(indx),1)
         call dluax(rwork(indr),nr,nr,z(indx),iwork(l3+2),
     &              iwork(indi),icon)
         if(icon.ne.0) then
            write(*,*) " dluax error, icon =", icon
	      stop
         endif
         iwork(l3+2) = 2
	enddo

      return
      end

c-------------------------------------------------------------------------------
c   This subroutine solves linear system of equations Ax=b by LU decomposition.
c
c   a   .... given regular coefficient matrix.
c   k   .... given adjustable dimension for array a.
c   n   .... given order of matrix a.
c   b   .... given constant vector.
c   isw .... given control information:
c             if 1, solve equations entirely.
c             if 2, solve equations with last lu-decomposed entries.
c   ip  .... auxiliary 1 dimensioned array, size is n.
c             transposition vector which represents
c             row-exchanging by partial pivoting.
c   icon.... resultant condition code.
c
c   Slave subroutines used (available at www.netlib.org):
c     dgetrf, dgetrs
c
c-------------------------------------------------------------------------------

      subroutine dluax(a,k,n,b,isw,ip,icon)
      
      implicit real*8 (a-h,o-z)
      dimension a(k,n),b(n),ip(n)
      data ione/1/
      
      icon = 30000
      if(isw.eq.1) go to 1000
      if(isw.eq.2) go to 1100
      go to 8000
 1000 call dgetrf(n,n,a,k,ip,icon)
      isw = 2
 1100 call dgetrs('n',n,ione,a,k,ip,b,n,icon)
 8000 continue
 
      return
      end

c-------------------------------------------------------------------------------