      subroutine prep_model(n,x,y,node,bc,dnorm,xfield,nfield,maxl,
     &                      levmx,nexp,ntylr,tolerance,
     &                      xmin,xmax,ymin,ymax)

      implicit real*8(a-h,o-z)

      dimension x(2,*),y(2,*),node(2,*),bc(2,*),dnorm(2,*),xfield(2,*)

	write(*,2) n, maxl, levmx, nexp, tolerance
	write(3,2) n, maxl, levmx, nexp, tolerance
2	format('  Total number of elements           =', I12
     &      /'  Max. number of elements in a leaf  =', I12
     &      /'  Max. number of tree levels         =', I12
     &      /'  Number of terms used in expansions =', I12
     &      /'  Tolerance for convergence          =', D12.3)
	write(*,*)
	write(3,*)

c Input the mesh data

	read(5,*)
	do i=1,n
	  read(5,*) itemp, y(1,i), y(2,i)
	enddo

	read(5,*)
	do i=1,n
	  read(5,*) itemp, node(1,i), node(2,i), bc(1,i), bc(2,i)
	enddo

c Input the field points inside the domain

	if (nfield .gt. 0) then
	read(5,*)
	do i=1,nfield
	  read(5,*) itemp, xfield(1,i), xfield(2,i)
	enddo
	endif

c Compute mid-nodes and normals of the elements

      do i=1,n
        x(1,i) = (y(1,node(1,i))+y(1,node(2,i)))*0.5
        x(2,i) = (y(2,node(1,i))+y(2,node(2,i)))*0.5
        h1 =  y(2,node(2,i)) - y(2,node(1,i))
        h2 = -y(1,node(2,i)) + y(1,node(1,i))
        el = sqrt(h1**2 + h2**2)
        dnorm(1,i) = h1/el
        dnorm(2,i) = h2/el
	enddo

c Determine the square bounding the problem domain (Largest cell used in FMM)

      xmin=x(1,1)
      xmax=x(1,1)
      ymin=x(2,1)
      ymax=x(2,1)

      do 10 i=2,n
         if(x(1,i).le.xmin) then
            xmin=x(1,i)
         elseif(x(1,i).ge.xmax) then
            xmax=x(1,i)
         endif
         if(x(2,i).le.ymin) then
            ymin=x(2,i)
         elseif(x(2,i).ge.ymax) then
            ymax=x(2,i)
         endif
10    continue

	scale = 1.05d0    ! Make the square slightly larger
      xyd   = max(xmax-xmin,ymax-ymin)/2.d0
	xyd   = xyd*scale
      cx    = (xmin+xmax)/2.d0
      cy    = (ymin+ymax)/2.d0
      xmin  = cx-xyd
      xmax  = cx+xyd
      ymin  = cy-xyd
      ymax  = cy+xyd

c Output nodal coordinates for plotting

      do i = 1,n
	  write(8,*) x(1,i), x(2,i)
	enddo

      return
      end