c-------------------------------------------------------------------------------

      subroutine tree(n,x,xmax,xmin,ymax,ymin,ielem,itree,level,loct,
     &                numt,ifath,lowlev,maxl,levmx,ncellmx,nleafmx,
     &                nwksz,iwork)

      implicit real*8(a-h,o-z)
      complex*16 a,b

      dimension x(2,*),ielem(*),itree(*),level(0:*),loct(*),numt(*),
     &          ifath(*), iwork(*), nwk(4)

      do i=1,n
        ielem(i) = i        ! Store the original element numbers in ielem
	enddo

c For the level 0 cell (largest cell)

      itree(1) = 0
      level(0) = 1
      level(1) = 2
      loct(1)  = 1
      ifath(1) = 1
      numt(1)  = n
      ndivx    = 1
      lowlev   = 1
      nleaf    = 0
      nswa     = 0

c For cells on level 1 to the lowest level (leaves)

      do 10 lev=1,levmx
         levp        = lev-1
         levn        = lev+1
         level(levn) = level(lev)
         if(level(lev).eq.level(levp)) goto 900
         ndivxp = ndivx
         ndivx  = 2*ndivxp
         dxp    = (xmax-xmin)/ndivxp    ! Parent cell size
         dyp    = (ymax-ymin)/ndivxp    

         do 11 inp=level(levp),level(lev)-1
            itrp = itree(inp)
            if(numt(inp).gt.maxl .or. 
     &         (lev.le.2 .and. numt(inp).ne.0) ) then 
               itrpx = mod(itrp,ndivxp)
               itrpy = itrp/ndivxp
               xsep  = xmin+(itrpx + 0.5d0)*dxp
               ysep  = ymin+(itrpy + 0.5d0)*dyp

               call bisec(x,ielem(loct(inp)),numt(inp),ysep,nsepy, 2)
               call bisec(x,ielem(loct(inp)),nsepy-1,  xsep,nsepx1,1)
               call bisec(x,ielem(loct(inp)+nsepy-1),
     &                    numt(inp)-nsepy+1,xsep,nsepx2,1)
               nwk(1) = nsepx1-1
               nwk(2) = nsepy-nsepx1
               nwk(3) = nsepx2-1
               nwk(4) = numt(inp)-nsepy-nsepx2+2
               locc   = loct(inp)
               do 12 icldy=0,1
               do 12 icldx=0,1
                  icld = icldy*2+icldx+1

                  if(nwk(icld).gt.0) then
                     nrel = level(levn)
                     if(nrel.gt.ncellmx) then
			  	       write(*,*) " ncellmx error"
	                 stop
	               endif
                     itree(nrel) = ((itrpy*2+icldy)*ndivxp + itrpx)*2
     &                             +icldx
                     loct(nrel)  = locc
                     numt(nrel)  = nwk(icld)
                     ifath(nrel) = inp
                     lowlev=lev
c Leaves:
                     if((lev.ne.1) .and.
     &                  (numt(nrel).le.maxl .or. lev.eq.levmx)) then  ! Reach a leaf
                        nleaf = nleaf+1
                          if(nleaf.gt.nleafmx) then
				            write(*,*) " nleafmx error"
	                      stop
	                    endif
                        nleaf3          = nleaf*3 - 1
                        iwork(nleaf3)   = nrel          ! Store cell number (icell)
                        iwork(nleaf3+1) = nswa + 1      ! Store starting location of pre-cond matrix
                        iwork(nleaf3+2) = 1             ! Initial value of switch isw
                        nswa            = nswa + numt(nrel)**2  ! Size of pre-cond matrix
                        if(nswa.gt.nwksz) then
			  	          write(*,*) " nwksz error"
	                    stop
	                  endif
                     endif

                     level(levn) = nrel + 1
                     locc        = locc + nwk(icld)
                  endif
 12            continue
            endif
 11      continue
 10   continue

 900  iwork(1) = nleaf                               ! Store number of leaves in iwork(1)

	write(3,*) ' Number of tree levels              =', lowlev
      write(*,*) ' Number of tree levels              =', lowlev
	write(3,*) ' Number of leaves                   =', nleaf
      write(*,*) ' Number of leaves                   =', nleaf
      write(3,*) ' Number of cells                    =', nrel
      write(*,*) ' Number of cells                    =', nrel
	write(3,*)
      write(*,*)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Output the quad-tree structure for checking:

	write(*,*) ' The quad-tree strcuture:'
	write(3,*) ' The quad-tree strcuture:'
	write(*,*) '  Cell No.   itree     loct     numt    ifath    ielem'
	write(3,*) '  Cell No.   itree     loct     numt    ifath    ielem'
	do i=1,nrel
	  write(*,100) i, itree(i), loct(i), numt(i), ifath(i), ielem(i)
	  write(3,100) i, itree(i), loct(i), numt(i), ifath(i), ielem(i)
	enddo
100	format (6I9)
	write(*,*)
	write(3,*)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      return
      end

c-------------------------------------------------------------------------------

      subroutine bisec(x,ielem,n,xsep,nsep,ic)

      implicit real*8(a-h,o-z)

      dimension x(2,*),ielem(*)

      nsep = 1
      if(n.le.0) return

      do ifr=1,n
         if(x(ic,ielem(ifr)).le.xsep) then
            if(ifr.ne.nsep) then
               istore      = ielem(nsep)
               ielem(nsep) = ielem(ifr)
               ielem(ifr)  = istore
            endif
            nsep = nsep + 1
         endif
	enddo

      return
      end

c-------------------------------------------------------------------------------