      subroutine upward(u,n,y,node,dnorm,bc,a,xmax,xmin,ymax,ymin,ielem,
     &             itree,level,loct,numt,ifath,nexp,ncellmx,lowlev,maxl)

      implicit real*8(a-h,o-z)
      complex*16 a,b, z0,zi

      dimension a(0:nexp,ncellmx),
     &          y(2,*),node(2,*),dnorm(2,*),bc(2,*),u(*),
     &          ielem(*),itree(*),level(0:*),loct(*),numt(*),ifath(*)

      do i=1,level(lowlev+1)-1
      do k=0,nexp
         a(k,i) = (0.d0,0.d0)       ! Clear multipole moments
	enddo
	enddo

      do 10 lev=lowlev,2,-1         ! Loop from leaf to level 2 cells (Upward the tree)

         ndivx = 2**lev
         dx    = (xmax-xmin)/ndivx  ! Determine cell size
         dy    = (ymax-ymin)/ndivx

         do 20 icell=level(lev),level(lev+1)-1  ! Loop for level l cells
            itr  = itree(icell)
            itrx = mod(itr,ndivx)
            itry = itr/ndivx                    ! Position of the cell
            cx   = xmin+(itrx + 0.5d0)*dx
            cy   = ymin+(itry + 0.5d0)*dy       ! Center of the cell

c Multipole expansion

            if(numt(icell).le.maxl .or. lev.eq.lowlev) then         ! Compute moment for leaf
               call moment(a(0,icell),y,node,ielem(loct(icell)),
     &                     numt(icell),nexp,cx,cy,u(loct(icell)),
     &					   bc,dnorm)
            endif

c M2M translation

            if(lev.ne.2) then           ! Do M2M translation to form moments for parent cell
               cxp = xmin+(int(itrx/2)*2 + 1)*dx
               cyp = ymin+(int(itry/2)*2 + 1)*dy    ! Center of the parent cell
               z0  = cmplx(cx-cxp, cy-cyp)          ! (z_c - z_c')
               io  = ifath(icell)                   ! Cell number of the parent cell

               zi = (1.d0,0.d0)
               do k=0,nexp
                  do m=k,nexp
                     a(m,io) = a(m,io) + zi*a(m-k,icell)    ! Use M2M translation
                  enddo
                  zi = zi*z0/(k+1)
               enddo
            endif

 20      continue

 10   continue

      return
      end